/* Copyright (c) 2009-2010, Alexander Graf <alex@wortkreuzung.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE. */

#pragma once

#include <sys/types.h>
#include <sys/functions.h>

/* not yet, but i am working on it */
#define _POSIX_VERSION	200809L
#define _POSIX2_VERSION	200809L
/* TODO: define more _POSIX versions (as described in SUSv4) */

#define STDIN_FILENO	0
#define STDOUT_FILENO	1
#define STDERR_FILENO	2

extern char **environ;

static inline __noreturn _exit(int status)
{
	register int r asm("r0") = status;
	asm volatile ("swi %[sc]" ::
		      "r" (r),
		      [sc] "i" (SC__EXIT));

	for (;;) ;	/* make compiler happy */
}

__syscalli0(pid_t, fork, SC_FORK) 
__syscalli3i123(int, execve, SC_EXECVE, const char *, char * const *, char * const *)
__syscalli1(int, close, SC_CLOSE, int)
__syscalli3(ssize_t, read, SC_READ, int, void *, size_t)
__syscalli3(ssize_t, write, SC_WRITE, int, const void *, size_t)
__syscalli0(pid_t, getpid, SC_GETPID)
__syscalli0(pid_t, getppid, SC_GETPPID)
__syscalli0(pid_t, setsid, SC_SETSID)
