/* Copyright (c) 2009, Alexander Graf <alex@wortkreuzung.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE. */

#pragma once

/* defines for MMC access through the SPI interface by using software SPI
 * (direct GPIO access) */

#define CS	(1 << 21)	/* MMC pin 1 - Chip Select (active-low) */
#define DI	(1 << 20)	/* MMC pin 2 - Data In */
				/* MMC pin 3 - Ground */
				/* MMC pin 4 - Power Supply */
#define CLK	(1 << 14)	/* MMC pin 5 - Serial Clock (active-low) */
				/* MMC pin 6 - Ground */
#define DO	(1 << 19)	/* MMC pin 7 - Data Out */

/* GPIO registers */
#define GPIO_BASE	0xe0028000
#define IOPIN		(*(volatile unsigned int *) (GPIO_BASE + 0x0))
#define IOSET		(*(volatile unsigned int *) (GPIO_BASE + 0x4))
#define IODIR		(*(volatile unsigned int *) (GPIO_BASE + 0x8))
#define IOCLR		(*(volatile unsigned int *) (GPIO_BASE + 0xc))

static inline int mmc_card_inserted(void)
{
	/* no such pin on the MMC slot of my board */
	return 1;
}
