/* Copyright (c) 2009, Alexander Graf <alex@wortkreuzung.net>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE. */

#pragma once

#include "cpu.h"

#define EXTRAM_SIZE	(16 << 20)

/* cycles for specified nanoseconds */
#define NS(x)		((x) * CPU_CLOCK / 1000000000)

#define R_tCK	7

#define R_RS		1
#define R_RASCAS	(3 | 3 << 8)
#define R_tRP		NS(20)
#define R_tRAS		NS(42)
#define R_tSREX		R_tXSR
#define R_tAPR		NS(35)		/* not listed in datasheet? */
#define R_tDAL		NS(5*R_tCK)
#define R_tWR		(NS(7)+1)
#define R_tRC		NS(70)
#define R_tRFC		NS(70)
#define R_tXSR		NS(70)
#define R_tRRD		NS(14)
#define R_tMRD		NS(2*R_tCK)
#define R_ADRMAP	(2 << 7 | 2 << 9 | 1 << 14)
